/*
 File: IMCCalcul.m 
 Abstract: The class that handles BMI calculation and interpretation.
 
 Copyright (C) 2011 Laurent68k. All Rights Reserved. 
 */

typedef enum TagClassification { None = 0, Famine = 1, Maigreur = 2, Normal = 3, Surpoids = 4, ObesiteModere = 5, ObesiteSevere = 6, ObesiteMassive = 7, ObesiteDegre1 = 8, ObesiteDegre2 = 9 } EClassification;
typedef enum TagPersonne { Adulte = 0, EnfantFille = 1, EnfantGarcon = 2 } Personne;

typedef struct {
	double limiteBasse;
	double limiteHaute;
	double limiteObesite;
} Triplet;

@interface IMCCalcul : NSObject {
	
	@protected

	double personne;
	double year;
	double month;

	double poids;
	double taille;

	double indice;
	int categorie;
	
	Triplet abaqueFille[18];
	Triplet abaqueGarcon[18];
}

//	Accessors to the parameters but not very usefull in this program
@property(readonly) double  personne;
@property(readonly) double  poids;
@property(readonly) double  taille;
@property(readonly) double  indice;
@property(readonly) int  categorie;

-(void) GetSeuils:(Personne)aPersonne:(int)aYear:(int)aMonth:(double *)seuilWarning:(double *)seuilCritical;

//	Methods to Assign and get the both results
- (void) Calcul:(Personne)aPersonne:(int)aYear:(int)aMonth:(double)aPoids:(double)aTaille;

@end
