/*
	File: IMCCalcul.m 
	Abstract: The class that handles BMI calculation and interpretation.
 
	Copyright (C) 2011 Laurent68k. All Rights Reserved. 
 */


#import "IMCCalcul.h"

@implementation IMCCalcul

@synthesize personne;
@synthesize  poids;
@synthesize  taille;
@synthesize  indice;
@synthesize  categorie;

//	Initialise l'abaque des filles de 0 à 18 ans
-(void) InitAbaqueFille {
	
	self->abaqueFille[0].limiteBasse = 0;
	self->abaqueFille[0].limiteHaute = 0;
	self->abaqueFille[0].limiteObesite = 0;
	
	self->abaqueFille[1].limiteBasse = 14.75;
	self->abaqueFille[1].limiteHaute = 20;
	self->abaqueFille[1].limiteObesite = 1000;				//	Pas valable pour cet age

	self->abaqueFille[2].limiteBasse = 14.20;
	self->abaqueFille[2].limiteHaute = 19.15;
	self->abaqueFille[2].limiteObesite = 19.8;

	self->abaqueFille[3].limiteBasse = 13.75;
	self->abaqueFille[3].limiteHaute = 18.5;
	self->abaqueFille[3].limiteObesite = 19.4;

	self->abaqueFille[4].limiteBasse = 13.5;
	self->abaqueFille[4].limiteHaute = 18;
	self->abaqueFille[4].limiteObesite = 13.2;

	self->abaqueFille[5].limiteBasse = 13.1;
	self->abaqueFille[5].limiteHaute = 17.75;
	self->abaqueFille[5].limiteObesite = 19.2;

	self->abaqueFille[6].limiteBasse = 13;
	self->abaqueFille[6].limiteHaute = 17.75;
	self->abaqueFille[6].limiteObesite = 19.7;
	
	self->abaqueFille[7].limiteBasse = 13;
	self->abaqueFille[7].limiteHaute = 18;
	self->abaqueFille[7].limiteObesite = 20.5;

	self->abaqueFille[8].limiteBasse = 13.1;
	self->abaqueFille[8].limiteHaute = 18.5;
	self->abaqueFille[8].limiteObesite = 21.5;

	self->abaqueFille[9].limiteBasse = 13.25;
	self->abaqueFille[9].limiteHaute = 19.1;
	self->abaqueFille[9].limiteObesite = 22.80;

	self->abaqueFille[10].limiteBasse = 13.5;
	self->abaqueFille[10].limiteHaute = 20;
	self->abaqueFille[10].limiteObesite = 24.6;

	self->abaqueFille[11].limiteBasse = 13.80;
	self->abaqueFille[11].limiteHaute = 21;
	self->abaqueFille[11].limiteObesite = 25.4;

	self->abaqueFille[12].limiteBasse = 14.25;
	self->abaqueFille[12].limiteHaute = 22;
	self->abaqueFille[12].limiteObesite = 26.75;

	self->abaqueFille[13].limiteBasse = 14.75;
	self->abaqueFille[13].limiteHaute = 23.2;
	self->abaqueFille[13].limiteObesite = 27.75;

	self->abaqueFille[14].limiteBasse = 15.3;
	self->abaqueFille[14].limiteHaute = 24.25;
	self->abaqueFille[14].limiteObesite = 28.5;

	self->abaqueFille[15].limiteBasse = 15.80;
	self->abaqueFille[15].limiteHaute = 25.15;
	self->abaqueFille[15].limiteObesite = 29.10;
	
	self->abaqueFille[16].limiteBasse = 16.25;
	self->abaqueFille[16].limiteHaute = 25.75;
	self->abaqueFille[16].limiteObesite = 29.5;

	self->abaqueFille[17].limiteBasse = 16.5;
	self->abaqueFille[17].limiteHaute = 26;
	self->abaqueFille[17].limiteObesite = 29.7;
}

//	Initialise l'abaque des garcons de 0 à 18 ans
-(void) InitAbaqueGarcon {
	
	self->abaqueFille[0].limiteBasse = 0;
	self->abaqueFille[0].limiteHaute = 0;
	self->abaqueFille[0].limiteObesite = 0;
	
	self->abaqueFille[1].limiteBasse = 15;
	self->abaqueFille[1].limiteHaute = 20.4;
	self->abaqueFille[1].limiteObesite = 1000;				//	Pas valable pour cet age
	
	self->abaqueFille[2].limiteBasse = 14.50;
	self->abaqueFille[2].limiteHaute = 19.25;
	self->abaqueFille[2].limiteObesite = 20.1;
	
	self->abaqueFille[3].limiteBasse = 14;
	self->abaqueFille[3].limiteHaute = 18.4;
	self->abaqueFille[3].limiteObesite = 19.5;
	
	self->abaqueFille[4].limiteBasse = 13.75;
	self->abaqueFille[4].limiteHaute = 18;
	self->abaqueFille[4].limiteObesite = 19.4;
	
	self->abaqueFille[5].limiteBasse = 13.5;
	self->abaqueFille[5].limiteHaute = 17.9;
	self->abaqueFille[5].limiteObesite = 19.3;
	
	self->abaqueFille[6].limiteBasse = 13.4;
	self->abaqueFille[6].limiteHaute = 18;
	self->abaqueFille[6].limiteObesite = 19.75;
	
	self->abaqueFille[7].limiteBasse = 13.4;
	self->abaqueFille[7].limiteHaute = 18.25;
	self->abaqueFille[7].limiteObesite = 20.7;
	
	self->abaqueFille[8].limiteBasse = 13.5;
	self->abaqueFille[8].limiteHaute = 18.75;
	self->abaqueFille[8].limiteObesite = 21.5;
	
	self->abaqueFille[9].limiteBasse = 13.55;
	self->abaqueFille[9].limiteHaute = 19.4;
	self->abaqueFille[9].limiteObesite = 22.75;
	
	self->abaqueFille[10].limiteBasse = 13.75;
	self->abaqueFille[10].limiteHaute = 20;
	self->abaqueFille[10].limiteObesite = 24;
	
	self->abaqueFille[11].limiteBasse = 14;
	self->abaqueFille[11].limiteHaute = 20.65;
	self->abaqueFille[11].limiteObesite = 25.1;
	
	self->abaqueFille[12].limiteBasse = 14.3;
	self->abaqueFille[12].limiteHaute = 21.5;
	self->abaqueFille[12].limiteObesite = 26;
	
	self->abaqueFille[13].limiteBasse = 14.5;
	self->abaqueFille[13].limiteHaute = 22.25;
	self->abaqueFille[13].limiteObesite = 26.80;
	
	self->abaqueFille[14].limiteBasse = 15.80;
	self->abaqueFille[14].limiteHaute = 23.25;
	self->abaqueFille[14].limiteObesite = 27.5;
	
	self->abaqueFille[15].limiteBasse = 15.80;
	self->abaqueFille[15].limiteHaute = 24.00;
	self->abaqueFille[15].limiteObesite = 28.30;
	
	self->abaqueFille[16].limiteBasse = 16.30;
	self->abaqueFille[16].limiteHaute = 24.90;
	self->abaqueFille[16].limiteObesite = 28.90;
	
	self->abaqueFille[17].limiteBasse = 16.75;
	self->abaqueFille[17].limiteHaute = 25.5;
	self->abaqueFille[17].limiteObesite = 29.5;
}

//	Méthode surchargée init
-(id) init {
	
	self = [super init];
	
	[self InitAbaqueFille];
	[self InitAbaqueGarcon];
	
	return self;
}

//	Méthode de calcul pure de l'IMC
-(void) CalculIMC {

	//	Calcul l'IMC pour un adulte de 18 => 64 ans	
	self->indice = (self->poids / (self->taille * self->taille));
}

//	retourne les valeurs seuils Warning et Critique adulte
-(void) GetAdultSeuils:(double *)seuilWarning:(double *)seuilCritical {
	
	*seuilWarning = 25.0;
	*seuilCritical = 30.0;
}

//	retourne les valeurs seuils Warning et Critique fille
-(void) GetFilleSeuils:(int)aYear: (double *)seuilWarning:(double *)seuilCritical {
	
	*seuilWarning = self->abaqueFille[aYear].limiteHaute;
	*seuilCritical = self->abaqueFille[aYear].limiteObesite;
}

//	retourne les valeurs seuils Warning et Critique garcon
-(void) GetGarconSeuils:(int)aYear: (double *)seuilWarning:(double *)seuilCritical {
	
	*seuilWarning = self->abaqueGarcon[aYear].limiteHaute;
	*seuilCritical = self->abaqueGarcon[aYear].limiteObesite;
}

//	retourne les valeurs seuils Warning et Critique pour un type de personne/age
-(void) GetSeuils:(Personne)aPersonne:(int)aYear:(int)aMonth:(double *)seuilWarning:(double *)seuilCritical {
	
	switch(aPersonne) {
			
		case EnfantFille:
			[self GetFilleSeuils:aYear: seuilWarning : seuilCritical];
			break;
			
		case EnfantGarcon:
			[self GetGarconSeuils:aYear: seuilWarning : seuilCritical];
			break;

		case Adulte:
		default:
			[self GetAdultSeuils:seuilWarning :seuilCritical];
			break;
	}
}

//	Méthode "privée" de calcule & d'interprétation de l'IMC adulte
-(void) CalculAdult {
	
	[self CalculIMC];
	
	//	Calcul de la classification
	if( self->indice < 15.0 ) {
		self->categorie =  Famine;
	}
	else if( self->indice >= 15 && self->indice <= 18.5 ) {
		self->categorie = Maigreur;
	}
	else if( self->indice >= 18.5 && self->indice <= 24.9 ) {
		self->categorie =  Normal;
	}
	else if( self->indice >= 25.0 && self->indice <= 29.9 ) {
		self->categorie =  Surpoids;
	}
	else if( self->indice >= 30 && self->indice < 34.9 ) {
		self->categorie =  ObesiteModere;
	}
	else if( self->indice >= 35 && self->indice < 39.9 ) {
		self->categorie =  ObesiteSevere;
	}
	else {
		self->categorie = ObesiteMassive;
	}
}

//	Méthode "privée" de calcule & d'interprétation de l'IMC enfant 
-(void)CalculEnfant:(Triplet [])aAbaque {

	[self CalculIMC];
	
	//int age = self->year * 12 + self->month;
	
	//Triplet points = self->abaqueFille[ (int)self->year ];
	Triplet points = aAbaque[ (int)self->year ];
	
	if( points.limiteBasse == 0 && points.limiteHaute == 0 && points.limiteObesite == 0 ) {
		
		self->categorie = None;
		return;
	}
	
	if( self->indice < points.limiteBasse ) {
		self->categorie = Maigreur;
	}
	else if( self->indice <= points.limiteHaute ) {
		self->categorie = Normal;
	}
	else if( self->indice <= points.limiteObesite ) {
		self->categorie = ObesiteDegre1;
	}
	else {
		self->categorie = ObesiteDegre2;
	}
}

//	Méthode publique de calcul complet
//	Poids en kG et taille en cm
- (void) Calcul:(Personne)aPersonne:(int)aYear:(int)aMonth:(double)aPoids:(double)aTaille {
	
	//	Store the parameters
	self->personne = aPersonne;
	self->year = aYear;
	self->month = aMonth;
	
	self->poids = aPoids;
	self->taille = aTaille / 100;
	
	if( self->personne == EnfantFille ) {
		
		[self CalculEnfant: self->abaqueFille];
	}
	else if( self->personne == EnfantGarcon ) {
		
		[self CalculEnfant: self->abaqueGarcon];
	}
	else {
		[self CalculAdult];
	}
}

@end
