/*
	File: WndIMCController.m 
	Abstract: The class that handles the interaction between the GUI and the IMCCalcul object
 
	Copyright (C) 2011 Laurent68k. All Rights Reserved.
 */

#import "IMCCalcul.h"

@interface WndIMCController : NSWindowController
{  
	IMCCalcul *calculator;

    // points to poids field
    IBOutlet NSTextField *tfPoids;
    
    // points to taille field
    IBOutlet NSTextField *tfTaille;

	// points to IMC field
    IBOutlet NSTextField *tfIndice;

	// points to Classification field
    IBOutlet NSTextField *tfClassification;

	IBOutlet NSLevelIndicator *liIndicator;
	
	IBOutlet NSSlider *sldPoids;
	IBOutlet NSSlider *sldTaille;
	
	IBOutlet NSMatrix *rbMatrix;
	
	IBOutlet NSStepper *stpYear;	
	IBOutlet NSStepper *stpMonth;
	
	IBOutlet NSTextField *lbYear;
	IBOutlet NSTextField *lbMonth;
}

@property(readonly) IMCCalcul *calculator;

- (void)controlTextDidChange:(NSNotification *)notification;

- (IBAction)sldPoidsChange:(id)sender;

- (IBAction)sldTailleChange:(id)sender;

- (IBAction)rbAgeSelected:(id)sender;

- (IBAction)stepperChange:(id)sender;

- (void) Calculer;

@end
